#ifndef APPLICATION_H
#define APPLICATION_H

#include <vector>
#include "gl_viewer.h"
#include "fractal_util.h"
/*
 * Where all of our magic happens.
 */
class application : public gl_viewer
{
public:
    application();
    virtual ~application();

    void init(int argc, char * argv[], int width, int height);
	 void draw_event();
    void keyboard_event(unsigned char key, int x, int y);
	  void mouse_event(
        mouse_button button, mouse_button_state button_state, 
        int x, int y
    );
	 
private:
	//computes the viewing window for your complex plane
	 complex_number viewport_to_complex_plane(rectangle viewport, rectangle complex_boundary,
	 	int x, int y);
	 //stores all viewing windows that have been made
	 std::vector <rectangle> zoom_history;
	 //holds information about the resolution of the image
    rectangle viewport;
	 //holds the most current information about the bounds on the imaginary plane
	 rectangle complex_boundary;
	 //holds information about the bounds future imaginary planes
	 rectangle new_complex_boundary;
	 //used for maintaining how many points have been stored
	 int counter;
	 //used to preserve the aspect ratio of the image when a new boundary is set
	 static const double aspect_ratio = 2.5/2.4;
}; // class application

#endif
