#include "fractal_util.h"


//converts the 
//pixel to a complex number.

complex_number viewport_to_complex_plane(
    const rectangle& viewport, const rectangle& complex_boundary,
    int x, int y
    )
{
    double viewport_width =  abs(viewport.x1 - viewport.x0);
    double viewport_height = abs(viewport.y1 - viewport.y0);
    
    double complex_boundary_width = abs(complex_boundary.x1 - complex_boundary.x0);
    double complex_boundary_height = abs(complex_boundary.y1 - complex_boundary.y0);

    complex_number z;

    z.set_components(
            x / viewport_width * complex_boundary_width + complex_boundary.x0,
            y / viewport_height * complex_boundary_height + complex_boundary.y0
        );

    return z;
}   

