#ifndef FRACTAL_UTIL_H
#define FRACTAL_UTIL_H

#include <cmath>
#include <iostream>

class rectangle
{
public:
    rectangle(){}
    
    rectangle(double x, double y, double x_1, double y_1)
    { x0 = x; y0 = y; x1 = x_1; y1 = y_1;}

    void set (double x, double y, double x_1, double y_1)
    { x0 = x; y0 = y; x1 = x_1; y1 = y_1;}

    void swap_x()
    {
        double temp = x0;
        x0 = x1;
        x1 = temp;
    }

    void swap_y()
    {
        double temp = y0;
        y0 = y1;
        y1 = temp;
    }

    double x0, y0;
    double x1, y1;
};

class complex_number
{
public:
    /*
     * takes in the real and imaginary
     * components values e.g. z = a + bi
     */
    complex_number(double a, double b)
        : m_a(a), m_b(b)
    {
    }

    complex_number()
        : m_a(1.0), m_b(1.0)
    {
    }
    
    /*
     * complex multiplication
     */
    complex_number operator*(const complex_number& rhs) const
    {
        complex_number result;

        result.m_a = m_a * rhs.m_a - m_b * rhs.m_b;
        result.m_b = m_a * rhs.m_b + m_b * rhs.m_a;
        
        return result;
    }

    /*
     * complex addition
     */
    complex_number operator+(const complex_number& rhs) const
    {
        complex_number result;

        result.m_a = m_a + rhs.m_a;
        result.m_b = m_b + rhs.m_b;

        return result;
    }

    /*
     * complex subtraction
     */
    complex_number operator-(const complex_number& rhs) const
    {
        complex_number result;

        result.m_a = m_a - rhs.m_a;
        result.m_b = m_b - rhs.m_b;

        return result;
    }

    /*
     * length
     */
    double length() const
    {
        return sqrt(m_a * m_a + m_b * m_b);
    }

    /*
     * get real and imaginary components
     */
    void get_components(double &a, double &b) const
    {
        a = m_a;
        b = m_b;
        //return m_a;
    }

    /*
     * set real and imaginary components
     */
    void set_components(double a, double b) 
    {
        m_a = a;
        m_b = b;
    }

    void print()
    {
        std::cout << "(" << m_a << "," << m_b << ")" << std:: endl;
    }

private:
    double m_a, m_b; // real and imaginary component;
    
}; // class complex_number

#endif
